<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfExtProductModel ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfExtProductModel
 * @subpackage Arrays
 */
class ArrayOfExtProductModel extends AbstractStructArrayBase
{
    /**
     * The ExtProductModel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ExtProductModel[]
     */
    public $ExtProductModel;
    /**
     * Constructor method for ArrayOfExtProductModel
     * @uses ArrayOfExtProductModel::setExtProductModel()
     * @param \StructType\ExtProductModel[] $extProductModel
     */
    public function __construct(array $extProductModel = array())
    {
        $this
            ->setExtProductModel($extProductModel);
    }
    /**
     * Get ExtProductModel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ExtProductModel[]|null
     */
    public function getExtProductModel()
    {
        return isset($this->ExtProductModel) ? $this->ExtProductModel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setExtProductModel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExtProductModel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExtProductModelForArrayConstraintsFromSetExtProductModel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfExtProductModelExtProductModelItem) {
            // validation for constraint: itemType
            if (!$arrayOfExtProductModelExtProductModelItem instanceof \StructType\ExtProductModel) {
                $invalidValues[] = is_object($arrayOfExtProductModelExtProductModelItem) ? get_class($arrayOfExtProductModelExtProductModelItem) : sprintf('%s(%s)', gettype($arrayOfExtProductModelExtProductModelItem), var_export($arrayOfExtProductModelExtProductModelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ExtProductModel property can only contain items of type \StructType\ExtProductModel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ExtProductModel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ExtProductModel[] $extProductModel
     * @return \ArrayType\ArrayOfExtProductModel
     */
    public function setExtProductModel(array $extProductModel = array())
    {
        // validation for constraint: array
        if ('' !== ($extProductModelArrayErrorMessage = self::validateExtProductModelForArrayConstraintsFromSetExtProductModel($extProductModel))) {
            throw new \InvalidArgumentException($extProductModelArrayErrorMessage, __LINE__);
        }
        if (is_null($extProductModel) || (is_array($extProductModel) && empty($extProductModel))) {
            unset($this->ExtProductModel);
        } else {
            $this->ExtProductModel = $extProductModel;
        }
        return $this;
    }
    /**
     * Add item to ExtProductModel value
     * @throws \InvalidArgumentException
     * @param \StructType\ExtProductModel $item
     * @return \ArrayType\ArrayOfExtProductModel
     */
    public function addToExtProductModel(\StructType\ExtProductModel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExtProductModel) {
            throw new \InvalidArgumentException(sprintf('The ExtProductModel property can only contain items of type \StructType\ExtProductModel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ExtProductModel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ExtProductModel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ExtProductModel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ExtProductModel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ExtProductModel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ExtProductModel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ExtProductModel
     */
    public function getAttributeName()
    {
        return 'ExtProductModel';
    }
}
