<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHintTown ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHintTown
 * @subpackage Arrays
 */
class ArrayOfHintTown extends AbstractStructArrayBase
{
    /**
     * The HintTown
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HintTown[]
     */
    public $HintTown;
    /**
     * Constructor method for ArrayOfHintTown
     * @uses ArrayOfHintTown::setHintTown()
     * @param \StructType\HintTown[] $hintTown
     */
    public function __construct(array $hintTown = array())
    {
        $this
            ->setHintTown($hintTown);
    }
    /**
     * Get HintTown value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HintTown[]|null
     */
    public function getHintTown()
    {
        return isset($this->HintTown) ? $this->HintTown : null;
    }
    /**
     * This method is responsible for validating the values passed to the setHintTown method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHintTown method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHintTownForArrayConstraintsFromSetHintTown(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfHintTownHintTownItem) {
            // validation for constraint: itemType
            if (!$arrayOfHintTownHintTownItem instanceof \StructType\HintTown) {
                $invalidValues[] = is_object($arrayOfHintTownHintTownItem) ? get_class($arrayOfHintTownHintTownItem) : sprintf('%s(%s)', gettype($arrayOfHintTownHintTownItem), var_export($arrayOfHintTownHintTownItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HintTown property can only contain items of type \StructType\HintTown, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HintTown value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HintTown[] $hintTown
     * @return \ArrayType\ArrayOfHintTown
     */
    public function setHintTown(array $hintTown = array())
    {
        // validation for constraint: array
        if ('' !== ($hintTownArrayErrorMessage = self::validateHintTownForArrayConstraintsFromSetHintTown($hintTown))) {
            throw new \InvalidArgumentException($hintTownArrayErrorMessage, __LINE__);
        }
        if (is_null($hintTown) || (is_array($hintTown) && empty($hintTown))) {
            unset($this->HintTown);
        } else {
            $this->HintTown = $hintTown;
        }
        return $this;
    }
    /**
     * Add item to HintTown value
     * @throws \InvalidArgumentException
     * @param \StructType\HintTown $item
     * @return \ArrayType\ArrayOfHintTown
     */
    public function addToHintTown(\StructType\HintTown $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HintTown) {
            throw new \InvalidArgumentException(sprintf('The HintTown property can only contain items of type \StructType\HintTown, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HintTown[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HintTown|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HintTown|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HintTown|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HintTown|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HintTown|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HintTown
     */
    public function getAttributeName()
    {
        return 'HintTown';
    }
}
