<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMPExtProductModel ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMPExtProductModel
 * @subpackage Arrays
 */
class ArrayOfMPExtProductModel extends AbstractStructArrayBase
{
    /**
     * The MPExtProductModel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MPExtProductModel[]
     */
    public $MPExtProductModel;
    /**
     * Constructor method for ArrayOfMPExtProductModel
     * @uses ArrayOfMPExtProductModel::setMPExtProductModel()
     * @param \StructType\MPExtProductModel[] $mPExtProductModel
     */
    public function __construct(array $mPExtProductModel = array())
    {
        $this
            ->setMPExtProductModel($mPExtProductModel);
    }
    /**
     * Get MPExtProductModel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MPExtProductModel[]|null
     */
    public function getMPExtProductModel()
    {
        return isset($this->MPExtProductModel) ? $this->MPExtProductModel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMPExtProductModel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMPExtProductModel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMPExtProductModelForArrayConstraintsFromSetMPExtProductModel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMPExtProductModelMPExtProductModelItem) {
            // validation for constraint: itemType
            if (!$arrayOfMPExtProductModelMPExtProductModelItem instanceof \StructType\MPExtProductModel) {
                $invalidValues[] = is_object($arrayOfMPExtProductModelMPExtProductModelItem) ? get_class($arrayOfMPExtProductModelMPExtProductModelItem) : sprintf('%s(%s)', gettype($arrayOfMPExtProductModelMPExtProductModelItem), var_export($arrayOfMPExtProductModelMPExtProductModelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MPExtProductModel property can only contain items of type \StructType\MPExtProductModel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MPExtProductModel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MPExtProductModel[] $mPExtProductModel
     * @return \ArrayType\ArrayOfMPExtProductModel
     */
    public function setMPExtProductModel(array $mPExtProductModel = array())
    {
        // validation for constraint: array
        if ('' !== ($mPExtProductModelArrayErrorMessage = self::validateMPExtProductModelForArrayConstraintsFromSetMPExtProductModel($mPExtProductModel))) {
            throw new \InvalidArgumentException($mPExtProductModelArrayErrorMessage, __LINE__);
        }
        if (is_null($mPExtProductModel) || (is_array($mPExtProductModel) && empty($mPExtProductModel))) {
            unset($this->MPExtProductModel);
        } else {
            $this->MPExtProductModel = $mPExtProductModel;
        }
        return $this;
    }
    /**
     * Add item to MPExtProductModel value
     * @throws \InvalidArgumentException
     * @param \StructType\MPExtProductModel $item
     * @return \ArrayType\ArrayOfMPExtProductModel
     */
    public function addToMPExtProductModel(\StructType\MPExtProductModel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MPExtProductModel) {
            throw new \InvalidArgumentException(sprintf('The MPExtProductModel property can only contain items of type \StructType\MPExtProductModel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MPExtProductModel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MPExtProductModel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MPExtProductModel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MPExtProductModel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MPExtProductModel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MPExtProductModel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MPExtProductModel
     */
    public function getAttributeName()
    {
        return 'MPExtProductModel';
    }
}
