<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderInfoHeaderService ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOrderInfoHeaderService
 * @subpackage Arrays
 */
class ArrayOfOrderInfoHeaderService extends AbstractStructArrayBase
{
    /**
     * The OrderInfoHeaderService
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrderInfoHeaderService[]
     */
    public $OrderInfoHeaderService;
    /**
     * Constructor method for ArrayOfOrderInfoHeaderService
     * @uses ArrayOfOrderInfoHeaderService::setOrderInfoHeaderService()
     * @param \StructType\OrderInfoHeaderService[] $orderInfoHeaderService
     */
    public function __construct(array $orderInfoHeaderService = array())
    {
        $this
            ->setOrderInfoHeaderService($orderInfoHeaderService);
    }
    /**
     * Get OrderInfoHeaderService value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrderInfoHeaderService[]|null
     */
    public function getOrderInfoHeaderService()
    {
        return isset($this->OrderInfoHeaderService) ? $this->OrderInfoHeaderService : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrderInfoHeaderService method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrderInfoHeaderService method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrderInfoHeaderServiceForArrayConstraintsFromSetOrderInfoHeaderService(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrderInfoHeaderServiceOrderInfoHeaderServiceItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrderInfoHeaderServiceOrderInfoHeaderServiceItem instanceof \StructType\OrderInfoHeaderService) {
                $invalidValues[] = is_object($arrayOfOrderInfoHeaderServiceOrderInfoHeaderServiceItem) ? get_class($arrayOfOrderInfoHeaderServiceOrderInfoHeaderServiceItem) : sprintf('%s(%s)', gettype($arrayOfOrderInfoHeaderServiceOrderInfoHeaderServiceItem), var_export($arrayOfOrderInfoHeaderServiceOrderInfoHeaderServiceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OrderInfoHeaderService property can only contain items of type \StructType\OrderInfoHeaderService, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrderInfoHeaderService value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OrderInfoHeaderService[] $orderInfoHeaderService
     * @return \ArrayType\ArrayOfOrderInfoHeaderService
     */
    public function setOrderInfoHeaderService(array $orderInfoHeaderService = array())
    {
        // validation for constraint: array
        if ('' !== ($orderInfoHeaderServiceArrayErrorMessage = self::validateOrderInfoHeaderServiceForArrayConstraintsFromSetOrderInfoHeaderService($orderInfoHeaderService))) {
            throw new \InvalidArgumentException($orderInfoHeaderServiceArrayErrorMessage, __LINE__);
        }
        if (is_null($orderInfoHeaderService) || (is_array($orderInfoHeaderService) && empty($orderInfoHeaderService))) {
            unset($this->OrderInfoHeaderService);
        } else {
            $this->OrderInfoHeaderService = $orderInfoHeaderService;
        }
        return $this;
    }
    /**
     * Add item to OrderInfoHeaderService value
     * @throws \InvalidArgumentException
     * @param \StructType\OrderInfoHeaderService $item
     * @return \ArrayType\ArrayOfOrderInfoHeaderService
     */
    public function addToOrderInfoHeaderService(\StructType\OrderInfoHeaderService $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrderInfoHeaderService) {
            throw new \InvalidArgumentException(sprintf('The OrderInfoHeaderService property can only contain items of type \StructType\OrderInfoHeaderService, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OrderInfoHeaderService[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OrderInfoHeaderService|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OrderInfoHeaderService|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OrderInfoHeaderService|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OrderInfoHeaderService|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OrderInfoHeaderService|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderInfoHeaderService
     */
    public function getAttributeName()
    {
        return 'OrderInfoHeaderService';
    }
}
