<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'EnumerationOfint' => '\\StructType\\EnumerationOfint',
            'EnumerationBase' => '\\StructType\\EnumerationBase',
            'CustomerIntegrationModel' => '\\StructType\\CustomerIntegrationModel',
            'AccountModel' => '\\StructType\\AccountModel',
            'ArrayOfAccountAddress' => '\\ArrayType\\ArrayOfAccountAddress',
            'AccountAddress' => '\\StructType\\AccountAddress',
            'Unit' => '\\StructType\\Unit',
            'LovOrganization' => '\\StructType\\LovOrganization',
            'LovUnitGroup' => '\\StructType\\LovUnitGroup',
            'LovUnitType' => '\\StructType\\LovUnitType',
            'HintCity' => '\\StructType\\HintCity',
            'HintCountry' => '\\StructType\\HintCountry',
            'ArrayOfHintTown' => '\\ArrayType\\ArrayOfHintTown',
            'HintTown' => '\\StructType\\HintTown',
            'LovAddressType' => '\\StructType\\LovAddressType',
            'LovAuditCreatedVersion' => '\\StructType\\LovAuditCreatedVersion',
            'LovIdentityType' => '\\StructType\\LovIdentityType',
            'LovTaxExemptReason' => '\\StructType\\LovTaxExemptReason',
            'LovAccountType' => '\\StructType\\LovAccountType',
            'LovCustomerType' => '\\StructType\\LovCustomerType',
            'LovIntegrationType' => '\\StructType\\LovIntegrationType',
            'OrderInfoHeader' => '\\StructType\\OrderInfoHeader',
            'ArrayOfOrderInfoHeaderService' => '\\ArrayType\\ArrayOfOrderInfoHeaderService',
            'OrderInfoHeaderService' => '\\StructType\\OrderInfoHeaderService',
            'Service' => '\\StructType\\Service',
            'LovServiceType' => '\\StructType\\LovServiceType',
            'OrderInfoViewModel' => '\\StructType\\OrderInfoViewModel',
            'ArrayOfExtProductModel' => '\\ArrayType\\ArrayOfExtProductModel',
            'ExtProductModel' => '\\StructType\\ExtProductModel',
            'AddressInfoViewModel' => '\\StructType\\AddressInfoViewModel',
            'CustomerInfo' => '\\StructType\\CustomerInfo',
            'ResultInfo' => '\\StructType\\ResultInfo',
            'MPOrderInfoViewModel' => '\\StructType\\MPOrderInfoViewModel',
            'ArrayOfMPExtProductModel' => '\\ArrayType\\ArrayOfMPExtProductModel',
            'MPExtProductModel' => '\\StructType\\MPExtProductModel',
            'MPAddressInfoViewModel' => '\\StructType\\MPAddressInfoViewModel',
            'ArrayOfOrderInfoResponseModel' => '\\ArrayType\\ArrayOfOrderInfoResponseModel',
            'OrderInfoResponseModel' => '\\StructType\\OrderInfoResponseModel',
            'OrderHeaderModel' => '\\StructType\\OrderHeaderModel',
            'SaveOrder' => '\\StructType\\SaveOrder',
            'SaveOrderResponse' => '\\StructType\\SaveOrderResponse',
            'ArasMPOrder' => '\\StructType\\ArasMPOrder',
            'ArasMPOrderResponse' => '\\StructType\\ArasMPOrderResponse',
            'UpdateOrder' => '\\StructType\\UpdateOrder',
            'UpdateOrderResponse' => '\\StructType\\UpdateOrderResponse',
            'ArasMPOrderUpdate' => '\\StructType\\ArasMPOrderUpdate',
            'ArasMPOrderUpdateResponse' => '\\StructType\\ArasMPOrderUpdateResponse',
            'DeleteOrder' => '\\StructType\\DeleteOrder',
            'DeleteOrderResponse' => '\\StructType\\DeleteOrderResponse',
            'ArasMPOrderDelete' => '\\StructType\\ArasMPOrderDelete',
            'ArasMPOrderDeleteResponse' => '\\StructType\\ArasMPOrderDeleteResponse',
            'GetOrderListByDate' => '\\StructType\\GetOrderListByDate',
            'GetOrderListByDateResponse' => '\\StructType\\GetOrderListByDateResponse',
            'MPGetOrderListByDate' => '\\StructType\\MPGetOrderListByDate',
            'MPGetOrderListByDateResponse' => '\\StructType\\MPGetOrderListByDateResponse',
            'GetOrderListByOrderCode' => '\\StructType\\GetOrderListByOrderCode',
            'GetOrderListByOrderCodeResponse' => '\\StructType\\GetOrderListByOrderCodeResponse',
            'ArasMPOrderGetOrderListByOrderCode' => '\\StructType\\ArasMPOrderGetOrderListByOrderCode',
            'ArasMPOrderGetOrderListByOrderCodeResponse' => '\\StructType\\ArasMPOrderGetOrderListByOrderCodeResponse',
            'SaveOrderHeader' => '\\StructType\\SaveOrderHeader',
            'SaveOrderHeaderResponse' => '\\StructType\\SaveOrderHeaderResponse',
            'SaveOrderHeaderMPOrder' => '\\StructType\\SaveOrderHeaderMPOrder',
            'SaveOrderHeaderMPOrderResponse' => '\\StructType\\SaveOrderHeaderMPOrderResponse',
        );
    }
}
