<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MPOrderInfoViewModel StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:MPOrderInfoViewModel
 * @subpackage Structs
 */
class MPOrderInfoViewModel extends AbstractStructBase
{
    /**
     * The CodeExpireDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodeExpireDate;
    /**
     * The CollectionPrice
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CollectionPrice;
    /**
     * The ConfigurationId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ConfigurationId;
    /**
     * The ExtProductList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfMPExtProductModel
     */
    public $ExtProductList;
    /**
     * The ExtServiceCodeList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $ExtServiceCodeList;
    /**
     * The IntegrationCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IntegrationCode;
    /**
     * The InvoiceNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InvoiceNumber;
    /**
     * The LovCollectionType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LovCollectionType;
    /**
     * The LovPayOrType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LovPayOrType;
    /**
     * The MainServiceCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MainServiceCode;
    /**
     * The PieceCount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PieceCount;
    /**
     * The ReceiverAddressInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MPAddressInfoViewModel
     */
    public $ReceiverAddressInfo;
    /**
     * The SenderAddressInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MPAddressInfoViewModel
     */
    public $SenderAddressInfo;
    /**
     * The SpecialField1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SpecialField1;
    /**
     * The SpecialField2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SpecialField2;
    /**
     * The TradingWaybillNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TradingWaybillNumber;
    /**
     * The Volume
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Volume;
    /**
     * The Weight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Weight;
    /**
     * Constructor method for MPOrderInfoViewModel
     * @uses MPOrderInfoViewModel::setCodeExpireDate()
     * @uses MPOrderInfoViewModel::setCollectionPrice()
     * @uses MPOrderInfoViewModel::setConfigurationId()
     * @uses MPOrderInfoViewModel::setExtProductList()
     * @uses MPOrderInfoViewModel::setExtServiceCodeList()
     * @uses MPOrderInfoViewModel::setIntegrationCode()
     * @uses MPOrderInfoViewModel::setInvoiceNumber()
     * @uses MPOrderInfoViewModel::setLovCollectionType()
     * @uses MPOrderInfoViewModel::setLovPayOrType()
     * @uses MPOrderInfoViewModel::setMainServiceCode()
     * @uses MPOrderInfoViewModel::setPieceCount()
     * @uses MPOrderInfoViewModel::setReceiverAddressInfo()
     * @uses MPOrderInfoViewModel::setSenderAddressInfo()
     * @uses MPOrderInfoViewModel::setSpecialField1()
     * @uses MPOrderInfoViewModel::setSpecialField2()
     * @uses MPOrderInfoViewModel::setTradingWaybillNumber()
     * @uses MPOrderInfoViewModel::setVolume()
     * @uses MPOrderInfoViewModel::setWeight()
     * @param string $codeExpireDate
     * @param string $collectionPrice
     * @param string $configurationId
     * @param \ArrayType\ArrayOfMPExtProductModel $extProductList
     * @param \ArrayType\ArrayOfstring $extServiceCodeList
     * @param string $integrationCode
     * @param string $invoiceNumber
     * @param string $lovCollectionType
     * @param string $lovPayOrType
     * @param string $mainServiceCode
     * @param string $pieceCount
     * @param \StructType\MPAddressInfoViewModel $receiverAddressInfo
     * @param \StructType\MPAddressInfoViewModel $senderAddressInfo
     * @param string $specialField1
     * @param string $specialField2
     * @param string $tradingWaybillNumber
     * @param string $volume
     * @param string $weight
     */
    public function __construct($codeExpireDate = null, $collectionPrice = null, $configurationId = null, \ArrayType\ArrayOfMPExtProductModel $extProductList = null, \ArrayType\ArrayOfstring $extServiceCodeList = null, $integrationCode = null, $invoiceNumber = null, $lovCollectionType = null, $lovPayOrType = null, $mainServiceCode = null, $pieceCount = null, \StructType\MPAddressInfoViewModel $receiverAddressInfo = null, \StructType\MPAddressInfoViewModel $senderAddressInfo = null, $specialField1 = null, $specialField2 = null, $tradingWaybillNumber = null, $volume = null, $weight = null)
    {
        $this
            ->setCodeExpireDate($codeExpireDate)
            ->setCollectionPrice($collectionPrice)
            ->setConfigurationId($configurationId)
            ->setExtProductList($extProductList)
            ->setExtServiceCodeList($extServiceCodeList)
            ->setIntegrationCode($integrationCode)
            ->setInvoiceNumber($invoiceNumber)
            ->setLovCollectionType($lovCollectionType)
            ->setLovPayOrType($lovPayOrType)
            ->setMainServiceCode($mainServiceCode)
            ->setPieceCount($pieceCount)
            ->setReceiverAddressInfo($receiverAddressInfo)
            ->setSenderAddressInfo($senderAddressInfo)
            ->setSpecialField1($specialField1)
            ->setSpecialField2($specialField2)
            ->setTradingWaybillNumber($tradingWaybillNumber)
            ->setVolume($volume)
            ->setWeight($weight);
    }
    /**
     * Get CodeExpireDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodeExpireDate()
    {
        return isset($this->CodeExpireDate) ? $this->CodeExpireDate : null;
    }
    /**
     * Set CodeExpireDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codeExpireDate
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setCodeExpireDate($codeExpireDate = null)
    {
        // validation for constraint: string
        if (!is_null($codeExpireDate) && !is_string($codeExpireDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codeExpireDate, true), gettype($codeExpireDate)), __LINE__);
        }
        if (is_null($codeExpireDate) || (is_array($codeExpireDate) && empty($codeExpireDate))) {
            unset($this->CodeExpireDate);
        } else {
            $this->CodeExpireDate = $codeExpireDate;
        }
        return $this;
    }
    /**
     * Get CollectionPrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCollectionPrice()
    {
        return isset($this->CollectionPrice) ? $this->CollectionPrice : null;
    }
    /**
     * Set CollectionPrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $collectionPrice
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setCollectionPrice($collectionPrice = null)
    {
        // validation for constraint: string
        if (!is_null($collectionPrice) && !is_string($collectionPrice)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($collectionPrice, true), gettype($collectionPrice)), __LINE__);
        }
        if (is_null($collectionPrice) || (is_array($collectionPrice) && empty($collectionPrice))) {
            unset($this->CollectionPrice);
        } else {
            $this->CollectionPrice = $collectionPrice;
        }
        return $this;
    }
    /**
     * Get ConfigurationId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getConfigurationId()
    {
        return isset($this->ConfigurationId) ? $this->ConfigurationId : null;
    }
    /**
     * Set ConfigurationId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $configurationId
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setConfigurationId($configurationId = null)
    {
        // validation for constraint: string
        if (!is_null($configurationId) && !is_string($configurationId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($configurationId, true), gettype($configurationId)), __LINE__);
        }
        if (is_null($configurationId) || (is_array($configurationId) && empty($configurationId))) {
            unset($this->ConfigurationId);
        } else {
            $this->ConfigurationId = $configurationId;
        }
        return $this;
    }
    /**
     * Get ExtProductList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfMPExtProductModel|null
     */
    public function getExtProductList()
    {
        return isset($this->ExtProductList) ? $this->ExtProductList : null;
    }
    /**
     * Set ExtProductList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfMPExtProductModel $extProductList
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setExtProductList(\ArrayType\ArrayOfMPExtProductModel $extProductList = null)
    {
        if (is_null($extProductList) || (is_array($extProductList) && empty($extProductList))) {
            unset($this->ExtProductList);
        } else {
            $this->ExtProductList = $extProductList;
        }
        return $this;
    }
    /**
     * Get ExtServiceCodeList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getExtServiceCodeList()
    {
        return isset($this->ExtServiceCodeList) ? $this->ExtServiceCodeList : null;
    }
    /**
     * Set ExtServiceCodeList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $extServiceCodeList
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setExtServiceCodeList(\ArrayType\ArrayOfstring $extServiceCodeList = null)
    {
        if (is_null($extServiceCodeList) || (is_array($extServiceCodeList) && empty($extServiceCodeList))) {
            unset($this->ExtServiceCodeList);
        } else {
            $this->ExtServiceCodeList = $extServiceCodeList;
        }
        return $this;
    }
    /**
     * Get IntegrationCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIntegrationCode()
    {
        return isset($this->IntegrationCode) ? $this->IntegrationCode : null;
    }
    /**
     * Set IntegrationCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $integrationCode
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setIntegrationCode($integrationCode = null)
    {
        // validation for constraint: string
        if (!is_null($integrationCode) && !is_string($integrationCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($integrationCode, true), gettype($integrationCode)), __LINE__);
        }
        if (is_null($integrationCode) || (is_array($integrationCode) && empty($integrationCode))) {
            unset($this->IntegrationCode);
        } else {
            $this->IntegrationCode = $integrationCode;
        }
        return $this;
    }
    /**
     * Get InvoiceNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInvoiceNumber()
    {
        return isset($this->InvoiceNumber) ? $this->InvoiceNumber : null;
    }
    /**
     * Set InvoiceNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $invoiceNumber
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setInvoiceNumber($invoiceNumber = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceNumber) && !is_string($invoiceNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoiceNumber, true), gettype($invoiceNumber)), __LINE__);
        }
        if (is_null($invoiceNumber) || (is_array($invoiceNumber) && empty($invoiceNumber))) {
            unset($this->InvoiceNumber);
        } else {
            $this->InvoiceNumber = $invoiceNumber;
        }
        return $this;
    }
    /**
     * Get LovCollectionType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLovCollectionType()
    {
        return isset($this->LovCollectionType) ? $this->LovCollectionType : null;
    }
    /**
     * Set LovCollectionType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lovCollectionType
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setLovCollectionType($lovCollectionType = null)
    {
        // validation for constraint: string
        if (!is_null($lovCollectionType) && !is_string($lovCollectionType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lovCollectionType, true), gettype($lovCollectionType)), __LINE__);
        }
        if (is_null($lovCollectionType) || (is_array($lovCollectionType) && empty($lovCollectionType))) {
            unset($this->LovCollectionType);
        } else {
            $this->LovCollectionType = $lovCollectionType;
        }
        return $this;
    }
    /**
     * Get LovPayOrType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLovPayOrType()
    {
        return isset($this->LovPayOrType) ? $this->LovPayOrType : null;
    }
    /**
     * Set LovPayOrType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lovPayOrType
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setLovPayOrType($lovPayOrType = null)
    {
        // validation for constraint: string
        if (!is_null($lovPayOrType) && !is_string($lovPayOrType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lovPayOrType, true), gettype($lovPayOrType)), __LINE__);
        }
        if (is_null($lovPayOrType) || (is_array($lovPayOrType) && empty($lovPayOrType))) {
            unset($this->LovPayOrType);
        } else {
            $this->LovPayOrType = $lovPayOrType;
        }
        return $this;
    }
    /**
     * Get MainServiceCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMainServiceCode()
    {
        return isset($this->MainServiceCode) ? $this->MainServiceCode : null;
    }
    /**
     * Set MainServiceCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mainServiceCode
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setMainServiceCode($mainServiceCode = null)
    {
        // validation for constraint: string
        if (!is_null($mainServiceCode) && !is_string($mainServiceCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mainServiceCode, true), gettype($mainServiceCode)), __LINE__);
        }
        if (is_null($mainServiceCode) || (is_array($mainServiceCode) && empty($mainServiceCode))) {
            unset($this->MainServiceCode);
        } else {
            $this->MainServiceCode = $mainServiceCode;
        }
        return $this;
    }
    /**
     * Get PieceCount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPieceCount()
    {
        return isset($this->PieceCount) ? $this->PieceCount : null;
    }
    /**
     * Set PieceCount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pieceCount
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setPieceCount($pieceCount = null)
    {
        // validation for constraint: string
        if (!is_null($pieceCount) && !is_string($pieceCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pieceCount, true), gettype($pieceCount)), __LINE__);
        }
        if (is_null($pieceCount) || (is_array($pieceCount) && empty($pieceCount))) {
            unset($this->PieceCount);
        } else {
            $this->PieceCount = $pieceCount;
        }
        return $this;
    }
    /**
     * Get ReceiverAddressInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MPAddressInfoViewModel|null
     */
    public function getReceiverAddressInfo()
    {
        return isset($this->ReceiverAddressInfo) ? $this->ReceiverAddressInfo : null;
    }
    /**
     * Set ReceiverAddressInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\MPAddressInfoViewModel $receiverAddressInfo
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setReceiverAddressInfo(\StructType\MPAddressInfoViewModel $receiverAddressInfo = null)
    {
        if (is_null($receiverAddressInfo) || (is_array($receiverAddressInfo) && empty($receiverAddressInfo))) {
            unset($this->ReceiverAddressInfo);
        } else {
            $this->ReceiverAddressInfo = $receiverAddressInfo;
        }
        return $this;
    }
    /**
     * Get SenderAddressInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MPAddressInfoViewModel|null
     */
    public function getSenderAddressInfo()
    {
        return isset($this->SenderAddressInfo) ? $this->SenderAddressInfo : null;
    }
    /**
     * Set SenderAddressInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\MPAddressInfoViewModel $senderAddressInfo
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setSenderAddressInfo(\StructType\MPAddressInfoViewModel $senderAddressInfo = null)
    {
        if (is_null($senderAddressInfo) || (is_array($senderAddressInfo) && empty($senderAddressInfo))) {
            unset($this->SenderAddressInfo);
        } else {
            $this->SenderAddressInfo = $senderAddressInfo;
        }
        return $this;
    }
    /**
     * Get SpecialField1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSpecialField1()
    {
        return isset($this->SpecialField1) ? $this->SpecialField1 : null;
    }
    /**
     * Set SpecialField1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $specialField1
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setSpecialField1($specialField1 = null)
    {
        // validation for constraint: string
        if (!is_null($specialField1) && !is_string($specialField1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($specialField1, true), gettype($specialField1)), __LINE__);
        }
        if (is_null($specialField1) || (is_array($specialField1) && empty($specialField1))) {
            unset($this->SpecialField1);
        } else {
            $this->SpecialField1 = $specialField1;
        }
        return $this;
    }
    /**
     * Get SpecialField2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSpecialField2()
    {
        return isset($this->SpecialField2) ? $this->SpecialField2 : null;
    }
    /**
     * Set SpecialField2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $specialField2
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setSpecialField2($specialField2 = null)
    {
        // validation for constraint: string
        if (!is_null($specialField2) && !is_string($specialField2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($specialField2, true), gettype($specialField2)), __LINE__);
        }
        if (is_null($specialField2) || (is_array($specialField2) && empty($specialField2))) {
            unset($this->SpecialField2);
        } else {
            $this->SpecialField2 = $specialField2;
        }
        return $this;
    }
    /**
     * Get TradingWaybillNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTradingWaybillNumber()
    {
        return isset($this->TradingWaybillNumber) ? $this->TradingWaybillNumber : null;
    }
    /**
     * Set TradingWaybillNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tradingWaybillNumber
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setTradingWaybillNumber($tradingWaybillNumber = null)
    {
        // validation for constraint: string
        if (!is_null($tradingWaybillNumber) && !is_string($tradingWaybillNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tradingWaybillNumber, true), gettype($tradingWaybillNumber)), __LINE__);
        }
        if (is_null($tradingWaybillNumber) || (is_array($tradingWaybillNumber) && empty($tradingWaybillNumber))) {
            unset($this->TradingWaybillNumber);
        } else {
            $this->TradingWaybillNumber = $tradingWaybillNumber;
        }
        return $this;
    }
    /**
     * Get Volume value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVolume()
    {
        return isset($this->Volume) ? $this->Volume : null;
    }
    /**
     * Set Volume value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $volume
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setVolume($volume = null)
    {
        // validation for constraint: string
        if (!is_null($volume) && !is_string($volume)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($volume, true), gettype($volume)), __LINE__);
        }
        if (is_null($volume) || (is_array($volume) && empty($volume))) {
            unset($this->Volume);
        } else {
            $this->Volume = $volume;
        }
        return $this;
    }
    /**
     * Get Weight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWeight()
    {
        return isset($this->Weight) ? $this->Weight : null;
    }
    /**
     * Set Weight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $weight
     * @return \StructType\MPOrderInfoViewModel
     */
    public function setWeight($weight = null)
    {
        // validation for constraint: string
        if (!is_null($weight) && !is_string($weight)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($weight, true), gettype($weight)), __LINE__);
        }
        if (is_null($weight) || (is_array($weight) && empty($weight))) {
            unset($this->Weight);
        } else {
            $this->Weight = $weight;
        }
        return $this;
    }
}
