<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaveOrder StructType
 * @subpackage Structs
 */
class SaveOrder extends AbstractStructBase
{
    /**
     * The model
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrderInfoViewModel
     */
    public $model;
    /**
     * The customerInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CustomerInfo
     */
    public $customerInfo;
    /**
     * Constructor method for SaveOrder
     * @uses SaveOrder::setModel()
     * @uses SaveOrder::setCustomerInfo()
     * @param \StructType\OrderInfoViewModel $model
     * @param \StructType\CustomerInfo $customerInfo
     */
    public function __construct(\StructType\OrderInfoViewModel $model = null, \StructType\CustomerInfo $customerInfo = null)
    {
        $this
            ->setModel($model)
            ->setCustomerInfo($customerInfo);
    }
    /**
     * Get model value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrderInfoViewModel|null
     */
    public function getModel()
    {
        return isset($this->model) ? $this->model : null;
    }
    /**
     * Set model value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\OrderInfoViewModel $model
     * @return \StructType\SaveOrder
     */
    public function setModel(\StructType\OrderInfoViewModel $model = null)
    {
        if (is_null($model) || (is_array($model) && empty($model))) {
            unset($this->model);
        } else {
            $this->model = $model;
        }
        return $this;
    }
    /**
     * Get customerInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CustomerInfo|null
     */
    public function getCustomerInfo()
    {
        return isset($this->customerInfo) ? $this->customerInfo : null;
    }
    /**
     * Set customerInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\CustomerInfo $customerInfo
     * @return \StructType\SaveOrder
     */
    public function setCustomerInfo(\StructType\CustomerInfo $customerInfo = null)
    {
        if (is_null($customerInfo) || (is_array($customerInfo) && empty($customerInfo))) {
            unset($this->customerInfo);
        } else {
            $this->customerInfo = $customerInfo;
        }
        return $this;
    }
}
